unit Unit1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Cintl, StdCtrls, Grids, DBGrids, DB, DBTables, Mask,
  Menus, Buttons, ExtCtrls;

type
  TForm1 = class(TForm)
    STRINGbtn: TButton;
    INTL1: TINTL;
    LANGlbl: TLabel;
    LANGlb: TListBox;
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    MainMenu1: TMainMenu;
    Datei1: TMenuItem;
    Beenden1: TMenuItem;
    Hilfe1: TMenuItem;
    Info1: TMenuItem;
    WINbtn: TBitBtn;
    CLOSEbtn: TBitBtn;
    Panel1: TPanel;
    VENDORpnl: TPanel;
    SaveDialog1: TSaveDialog;
    Export1: TMenuItem;
    N1: TMenuItem;
    OpenDialog1: TOpenDialog;
    Import1: TMenuItem;
    UPDATEENVcb: TCheckBox;
    procedure STRINGbtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure LANGlbDblClick(Sender: TObject);
    procedure Info1Click(Sender: TObject);
    procedure WINbtnClick(Sender: TObject);
    procedure CLOSEbtnClick(Sender: TObject);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
    procedure INTL1Translate(Sender, Source: TObject; sClassName,
      sName: String; iType: Integer; var sCaption, sHint: OpenString;
      var bTranslate: Boolean);
    procedure INTL1NotSupported(Sender, Source: TObject; sClassName, sName,
      sCaption, sHint: String; iType: Integer);
    procedure Export1Click(Sender: TObject);
    procedure Import1Click(Sender: TObject);
    procedure UPDATEENVcbClick(Sender: TObject);
  private
    { Private-Deklarationen }
    procedure FillLANGcb;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

uses Unit2;
{$R *.DFM}

procedure TForm1.STRINGbtnClick(Sender: TObject);
begin
  MessageDlg(INTL1.GetMessage(1), mtInformation, [mbOK], 0);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  FillLANGcb;
end;

procedure TForm1.LANGlbDblClick(Sender: TObject);
begin
  {Set new lang}
  INTL1.SetLang(LANGlb.Items.Strings[LANGlb.ItemIndex]);
end;

procedure TForm1.Info1Click(Sender: TObject);
begin
  MessageDlg('INTL ' + INTL1.GetVersion + ' Demo', mtInformation, [mbOK], 0);
end;

procedure TForm1.WINbtnClick(Sender: TObject);
begin
  { Dont't create a Dialog within the project file. This will not work.}
  Form2 := TForm2.Create(self);
  Form2.ShowModal;
  Form2.Free;
end;

procedure TForm1.CLOSEbtnClick(Sender: TObject);
begin
  close;
end;

procedure TForm1.DataSource1DataChange(Sender: TObject; Field: TField);
begin
  if  (DataSource1.State = dsBrowse)
  and (Field = nil) then
  begin
    Panel1.Caption := FormatDateTime ('dddddd', Table1.FieldByName('DateField').AsDateTime);
  end;
end;

procedure TForm1.INTL1Translate(Sender, Source: TObject; sClassName,
  sName: String; iType: Integer; var sCaption, sHint: OpenString;
  var bTranslate: Boolean);
begin
  {This event occours, before any supported component will be translated}
  if  (sClassName = 'TForm')
  and (sName = 'Form1') then
  begin
    sCaption := sCaption + ' [' + INTL1.GetVersion + ']';
  end;
end;

procedure TForm1.INTL1NotSupported(Sender, Source: TObject; sClassName,
  sName, sCaption, sHint: String; iType: Integer);
begin
  {No fear, TPanel will be supported. But it's the only way to demonstrate
   the NotSupported Event.}

  if  (sClassName = 'TPanel')
  and (sName = 'VENDORpnl') then
  begin
    VENDORpnl.Caption := sCaption;
    VENDORpnl.Hint    := sHint;
  end;
end;

procedure TForm1.Export1Click(Sender: TObject);
begin
  {A simple possibility how to create a Database extract for your
   translater}
  if SaveDialog1.Execute then
  begin
    INTL1.SaveToFile(INTL1.GetLang, SaveDialog1.FileName);
  end;
end;

procedure TForm1.Import1Click(Sender: TObject);
begin
  { The translation is back}
  if OpenDialog1.Execute then
  begin
    INTL1.LoadFromFile(OpenDialog1.FileName);
    FillLANGcb;

  end;
end;

procedure TForm1.FillLANGcb;
var
  iCnt: Integer;

begin
  {Fill a StringList with all Languages, wich are stored in the database}
  INTL1.LangsToStringList(LANGlb.Items);

  for iCnt := 0 to LANGlb.Items.Count - 1 do
  begin
    if LANGlb.Items.Strings[iCnt] = INTL1.GetLang then
    begin
      LANGlb.ItemIndex := iCnt;
      break;
    end;
  end;
end;

procedure TForm1.UPDATEENVcbClick(Sender: TObject);
begin
  INTL1.UpdateEnv := UPDATEENVcb.Checked;
end;

end.
